freeslot("sfx_ptbint")

local thrownInf = {
	x = 0,
	y = 0,
	momx = 0,
	momy = 0,
	time = 0
}

local PTBoss
local function PTBossDetect(mo)
	PTBoss = mo
end
addHook("MobjSpawn", PTBossDetect, MT_BOSS_PEPPERMAN)

local function GetXYMod(v)
	local width = v.width()
	local height = v.height()
	
	width = 320
	height = 200
	
	local scalex, scalexFrac = v.dupx()
	local scaley, scaleyFrac = v.dupy()
	
	local widthMod = width * (scalexFrac % FRACUNIT)
	local heightMod = height * (scaleyFrac % FRACUNIT)
	
	return widthMod, heightMod
end

local function PizzaTowerBossHUD(v)
	local maxHP = 10
	local HP = 10
	local secondphase
	local mo = PTBoss

	if not (mo)
	or not (mo.valid)
		PTBoss = nil
		return
	end
	
	HP = mo.health - 10
	
	if (mo.secondphase) then
		HP = mo.health
		secondphase = mo.secondphase
	end

	//background elements
	local frameNum = 1 + ((leveltime/2) % 12)
	local bossHPicon = v.cachePatch("PTPMNHP\$frameNum\")
	local bossHPiconempty = v.cachePatch("PTPMNHPE\$frameNum\")
	local perRow = 5
	local icon = bossHPicon
	local screenWidth = (v.width()/v.dupx())*FRACUNIT
	
	local xresMod, yresMod = GetXYMod(v)
	
	for count = 1, maxHP do
		local xPosMod = ((maxHP - count) % perRow)
		
		if (count > HP)
		or (secondphase)
		and (leveltime < secondphase + (8*count))
			icon = bossHPiconempty
		end
	
		v.drawScaled((screenWidth - 15*FRACUNIT) - (25 * FRACUNIT * xPosMod),  (5*FRACUNIT) + (20 * FRACUNIT * ((count - 1)/5)), FRACUNIT/2, icon, V_SNAPTOTOP|V_SNAPTOLEFT)
	end
	
	
	//4:30AM nightmare code
	if (secondphase)
	and (leveltime < secondphase + (5*TICRATE))
		for count = 1, maxHP do
			local xPosMod = ((maxHP - count) % perRow)
			if (leveltime >= secondphase + (8*count))
			and (leveltime <= secondphase + (8*count) + 10) then
				local num = (leveltime - (secondphase + (8*count) + 10)) + 11
				
				if (num > 10) then
					num = 0
				end
				
				if (num) then
					v.drawScaled((screenWidth - 15*FRACUNIT) - (25 * FRACUNIT * xPosMod), (5*FRACUNIT) + (20 * FRACUNIT * ((count - 1)/5)), FRACUNIT/2, v.cachePatch("PTBOSSREG\$num\"), V_SNAPTOTOP|V_SNAPTOLEFT)
				end
			end
		end
	end
	
	if (mo.lasthit)
	and (mo.lasthit > thrownInf.time) then
		thrownInf = {
			x = 0,
			y = 0,
			momx = (-5*FRACUNIT) - (FRACUNIT/2),
			momy = -8*FRACUNIT,
			time = mo.lasthit
		}
	end
	
	if (thrownInf.time)
	and (thrownInf.time - leveltime) then
	
		local count = (mo.health + 1)
		if (count > 10) then
			count = $1 - 10
		end
		
		thrownInf.x = $1 + thrownInf.momx
		thrownInf.y = $1 + thrownInf.momy
		thrownInf.momy = $1 + ((FRACUNIT/4)*3)
		
		local scaleuseless, scaleMod
		
		local xPosMod = ((maxHP - count) % perRow)
		local x = (screenWidth - 15*FRACUNIT) - (25 * FRACUNIT * xPosMod)
		local y = (5*FRACUNIT) + (20 * FRACUNIT * ((count - 1)/5))
	
		v.drawScaled(x + thrownInf.x, y + thrownInf.y, FRACUNIT/2, bossHPicon, V_SNAPTOTOP|V_SNAPTOLEFT)
	end
end

hud.add(PizzaTowerBossHUD)

local fakeRandomPTX = {
	7,
	21,
	10,
	25,
	-22,
	1,
	-5,
	15,
	2,
	-2,
	6,
	-7,
	-9,
	1,
	-21,
	1,
	20,
	-15,
	-13,
	-21,
	6,
	-3,
	-23,
	-14,
	22,
	2,
	11,
	-24,
	23,
	19,
	-20,
	-25,
	-12,
	-1,
	10,
	-23,
	-2,
	21,
	23,
	0,
	18,
	-12,
	20,
	-20,
	1,
	18,
	3,
	10,
	-22,
	9,
	4,
	-2,
	-4,
	23,
	7,
	-3,
	8,
	25,
	-8,
	22,
	11,
	-1,
	2,
	-20,
	4,
	18,
	-4,
	24,
	-14,
	-24
}

local fakeRandomPTY = {
	23,
	-17,
	12,
	24,
	-5,
	9,
	-3,
	-11,
	20,
	-12,
	11,
	13,
	19,
	12,
	14,
	-21,
	14,
	-1,
	-12,
	5,
	-9,
	18,
	12,
	-9,
	-14,
	5,
	3,
	-23,
	-10,
	24,
	20,
	-2,
	14,
	12,
	23,
	24,
	-14,
	-21,
	12,
	-22,
	7,
	5,
	-16,
	0,
	0,
	-16,
	-19,
	7,
	22,
	19,
	-18,
	16,
	-13,
	-3,
	-16,
	12,
	-3,
	-8,
	-17,
	-21,
	-1,
	19,
	3,
	-5,
	22,
	-10,
	-1,
	-8,
	-3,
	21
}

local fadeStart = TICRATE + 10
local fracSpeed = FRACUNIT/2

local function GiveRandomXYMod()
	local randX = fakeRandomPTX[1 + (leveltime % #fakeRandomPTX)] * (FRACUNIT/10)
	local randY = fakeRandomPTY[1 + (leveltime % #fakeRandomPTY)] * (FRACUNIT/10)
	return randX, randY
end

local function DrawVsTitle(v, patch)
	local xPos = (160*FRACUNIT) - (patch.width/2)
	local yPos = (100*FRACUNIT) - (patch.height/2)
	
	local randX, randY = GiveRandomXYMod()
	
	xPos = $1 + randX
	yPos = $1 + randY
	v.drawScaled(xPos, yPos, FRACUNIT/3, patch)
end

local function DrawVsBackground(v, patch)
	local patchThird = 180*FRACUNIT
	local flameCount = ((leveltime % 90) + 1) * (FRACUNIT*2)
	local xPos = (160*FRACUNIT)// - (patch.width/2)
	local yPos = (100*FRACUNIT)// - (patch.height/2)
	
	yPos = $1 - flameCount
	
	for wideMod = -1, 1 do //widescreen fix
		for count = -2, 2 do
			//fixes whitespace between patches in software
			local softwareFix = (FRACUNIT/2) * count
			local flags = 0
			
			//widescreen fix
			if (wideMod) then
				flags = V_FLIP
			end
			local xMod = ((patch.width * FRACUNIT) / 3) * wideMod
			
			v.drawScaled(xPos + xMod, -softwareFix + yPos + (patchThird * count), FRACUNIT/3, patch, flags)
		end
	end
end

local function DrawPortraitSlide(v, patch, animTime, animLen, player)
	local xPos = 0
	if (animTime < animLen) then
		xPos = $1 - (((animLen - animTime) *fracSpeed) * (animLen - animTime))
	end	
	local randX, randY = 0
	
	//shake!
	if (animTime > fadeStart + TICRATE)
	and (animTime < fadeStart + TICRATE + TICRATE) then
		local randX, randY = GiveRandomXYMod()
		
		if (randX > 0) then
			randX = -$1
		end
		
		if (randY < 0) then
			randY = 0
		end
		
		randX = $1
		randY = $1
	end
	v.drawScaled(xPos+ randX, (200*FRACUNIT) + randY, FRACUNIT/3, patch, V_SNAPTOBOTTOM|V_SNAPTOLEFT, v.getColormap("sonic", player.skincolor))
end

//TC_RAINBOW gets confused so define our own skincolor instead
freeslot("SKINCOLOR_PIZZATOWERSHADOW")
skincolors[SKINCOLOR_PIZZATOWERSHADOW] = {
    name = "Pizza Tower Shadow",
    ramp = {31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31},
    accessible = false
}
local function DrawPlayerPortraitSlide(v, patch, animTime, animLen, player, shadow)
	local xPos = 0
	local height = 200*FRACUNIT
	local scale = FRACUNIT/3
	
	patch = v.getSprite2Patch(player.skin, SPR2_XTRA, false, B)
	height = $1 - ((patch.height * FRACUNIT))
	scale = FRACUNIT
	
	local color
	
	if (player.skincolor == skins[player.skin].prefcolor)
	or (skins[player.skin].prefcolor == SKINCOLOR_GREEN) //portrait will be green
		color = v.getColormap("sonic", player.skincolor)
	else
		color = v.getColormap(TC_RAINBOW, player.skincolor)
	end
	
	if (shadow) then
		color = v.getColormap(TC_BLINK, SKINCOLOR_PIZZATOWERSHADOW)
	end
	
	if (animTime < animLen) then
		xPos = $1 - (((animLen - animTime) *fracSpeed) * (animLen - animTime))
	end
	
	local randX, randY = 0,0
	
	//shake!
	if (animTime > fadeStart + TICRATE)
	and (animTime < fadeStart + TICRATE + TICRATE) then
		local randX, randY = GiveRandomXYMod()
		
		if (randX > 0) then
			randX = -$1
		end
		
		if (randY < 0) then
			randY = 0
		end
		
		randX = $1
		randY = $1
	end
	v.drawScaled(xPos+ randX, height + randY, scale, patch, V_SNAPTOBOTTOM|V_SNAPTOLEFT, color)
end

local function DrawPTBPlayerName(v, player)
	local xPos = (160*FRACUNIT)
	local yPos = (100*FRACUNIT)
	
	local randX, randY = GiveRandomXYMod()
	
	xPos = $1 + randX
	yPos = $1 + randY
	v.drawScaledNameTag(xPos - (150*FRACUNIT), yPos - (50*FRACUNIT), skins[player.skin].realname, 0, FRACUNIT, player.skincolor, SKINCOLOR_PIZZATOWERSHADOW)
end

local function DrawRightPortraitSlide(v, patch, animTime, animLen)
	local xPos = 320*FRACUNIT
	
	if (animTime < animLen) then
		xPos = $1 + (((animLen - animTime)*fracSpeed) * (animLen - animTime))
	end
	
	local randX, randY = 0,0
	//shake!
	if (animTime > fadeStart + TICRATE)
	and (animTime < fadeStart + TICRATE + TICRATE) then
		local randX, randY = GiveRandomXYMod()
		
		if (randX < 0) then
			randX = -$1
		end
		
		if (randY < 0) then
			randY = 0
		end
		
		randX = $1
		randY = $1
	end
	v.drawScaled(xPos + randX, (200*FRACUNIT) + randY, FRACUNIT/3, patch, V_SNAPTOBOTTOM|V_SNAPTORIGHT)
end

local function PizzaTowerBossIntro(v, player)
	//skip intro
	if not (gamemap == M_MapNumber("PM"))
	or (PTBLastMap == gamemap) then
		return
	end

	local startTime = 0,0

	local animTime = leveltime - startTime

	if (animTime >= 5*TICRATE)
		return
	end

	v.drawFill(nil, nil, nil, nil, 0)

	local peppinoPatch
	local bossPatch
	local shadowPatch = true

	if (animTime >= fadeStart+TICRATE) then
		peppinoPatch = v.cachePatch("PEPPINOVS")
		bossPatch =  v.cachePatch("VSPEPPER")
		DrawVsBackground(v, v.cachePatch("PTVSFLAME"))
		shadowPatch = false
	else
		peppinoPatch = v.cachePatch("PEPPINOVSB")
		bossPatch =  v.cachePatch("VSPEPPERB")
	end

	//DrawPortraitSlide(v, peppinoPatch, animTime, 15, player)
	DrawPlayerPortraitSlide(v, peppinoPatch, animTime, 15, player, shadowPatch)
	DrawRightPortraitSlide(v, bossPatch, animTime, 30)
	
	if (animTime >= fadeStart)
		if (animTime == fadeStart) then
			S_StartSound(nil, sfx_ptbint, player)
		end
		
		if (animTime < fadeStart+TICRATE) then
			local fadeStren = animTime - fadeStart
			
			if (fadeStren > 10) then
				fadeStren = 10
			end
			v.fadeScreen(0, fadeStren)
		else
			DrawVsTitle(v, v.cachePatch("VSPEPPERT"))
			DrawPTBPlayerName(v, player)
		end
	end
	
end
hud.add(PizzaTowerBossIntro)
